
#include <stdio.h>
#include <stdlib.h>

extern void	Error();

#define DIM	3

static int	Min(i1,i2)
int		i1,i2;
{
	return (i1<i2)?i1:i2;
}

static int	Max(i1,i2)
int		i1,i2;
{
	return (i1>i2)?i1:i2;
}

#define UNIT	sizeof(double)

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	coo,N1,N2,D1,D2,n1,n2,nd,L[DIM],Div=(argc-1)/DIM;
	double	l;

	if (Div<1 || Div>4 || (argc-1)%DIM!=0)
	    Error(
"usage : MB_rmsd_3d.VM Nx1 Ny1 Nz1 {Nx2 Ny2 Nz2} {Dx1 Dy1 Dz1 Dx2 Dy2 Dz2}"
	    );

	for (coo=0; coo<DIM; coo++) {
	    if (Div==1 || Div==3)
		N1=
		N2=atoi(argv[1+coo]);
	    else {
		N1=atoi(argv[1+coo]);
		N2=atoi(argv[1+DIM+coo]);
	    }
	    if (N1<=0 || N2<=0) Error("bad image size.");

	    if (Div==1 || Div==2) {
		D1=1-N2;
		D2=N1-1;
	    }
	    else {
		D1=atoi(argv[1+(Div-2)*DIM+coo]);
		D2=atoi(argv[1+(Div-1)*DIM+coo]);
	    }
	    if (D1>D2 || D1<=(-N2) || D2>=N1) Error("bad range of distance.");

	    n1=Min(N1,N2+D2);
	    n2=Min(N2,N1-D1); nd=(D2<0)?Max(n1,   n2+D2)+    D2 -D1 +1:
				 (D1>0)?Max(n1-D1,n2   )+    D2 -D1 +1:
					Max(n1,   n2   )+Max(D2,-D1)+1;

	    for (L[coo]=1; L[coo]<nd; L[coo]*=2) ;
	}
	l=4.0;
	for (coo=0; coo<DIM; coo++) {
	    (void)printf("%s%d",(coo==0)?"4*":"*",L[coo]);

	    l*=(double)L[coo];
	}
	(void)printf("*%d/(1024*1024)=%lf\n",
		     (int)UNIT,l*(double)UNIT/(1024.0*1024.0));

	return 0;
}
