
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

#ifndef	CSI_BS
#define	CSI_BS
#endif

#include "csi.h"

extern void	Error();

#define LEN	1023

static int	Scan(NBS)
char		*NBS;
{
	int	c,start=1,quote=0,len=0;

	for (;;) {
	    if ((c=getchar())==EOF) return 0;

	    if (start) {
		if (c==' ' || c=='\t' || c=='\n') continue;

		start=0;
	    }
	    if (quote==0) {
		if (c==' ' || c=='\t' || c=='\n') break;

		if (c=='"' || c=='\'') {
		    quote=c; continue;
		}
	    }
	    else
		if (c==quote) {
		    quote=0; continue;
		}

	    NBS[len]=c; if (++len==LEN) return 0;
	}
	NBS[len]='\0'; return 1;
}

typedef struct List {
		PBS		*mask,*data;
		int		Nx,Ny,Nz,Dx,Dy,Dz;
		struct List	*next;
	} List;

typedef struct {
		int	i;
		double	d;
	} Sum;

#define ALLOC(type,size)	(type *)malloc((size_t)(size)*sizeof(type))

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	mDir[LEN],mNBS[LEN],dDir[LEN],dNBS[LEN],
		format[LEN],desc[LEN],slice[LEN],path[LEN],
		*mae="memory allocation error.",
		*bis=" : bad image size.";
	int	Dx,Dy,Dz,x,y,z,x1,y1,z1,x2,y2,z2,X1,Y1,Z1,X2,Y2,Z2,BPS,len;
	List	*list,*top=NULL,**ptr=(&top);
	double	base,step,roof,none,val,min,max;
	Sum	**sum,**sy,*sx;
	Cell	**out,**mIn,**dIn;
	PBS	*mask,*data;

	if (argc!=4 && argc!=6 && argc!=10 && argc!=12)
	Error("usage : add_3d_wm none {base step} BPS {x1 y1 z1 x2 y2 z2} dir");

	while (scanf("%s",mDir)==1 && Scan(mNBS) &&
	       scanf("%s",dDir)==1 && Scan(dNBS) &&
	       scanf("%d %d %d",&Dx,&Dy,&Dz)==3) {
	    if ((list=ALLOC(List,1))==NULL) Error(mae);

	    list->mask=CheckSliceImages(mDir,mNBS,&(list->Nx),
						  &(list->Ny),
						  &(list->Nz),NULL);
	    list->data=CheckSliceImages(dDir,dNBS,&x,&y,&z,NULL);
	    if (x!=list->Nx || y!=list->Ny || z!=list->Nz) {
		(void)fprintf(stderr,"%s / %s",dDir,dNBS); Error(bis);
	    }
	    x2=(x1=list->Dx=Dx)+x-1;
	    y2=(y1=list->Dy=Dy)+y-1;
	    z2=(z1=list->Dz=Dz)+z-1;
	    if (top==NULL) {
		X1=x1; X2=x2;
		Y1=y1; Y2=y2;
		Z1=z1; Z2=z2;
	    }
	    else {
		if (x1<X1) X1=x1; if (x2>X2) X2=x2;
		if (y1<Y1) Y1=y1; if (y2>Y2) Y2=y2;
		if (z1<Z1) Z1=z1; if (z2>Z2) Z2=z2;
	    }
	    *ptr=list; *(ptr=(&(list->next)))=NULL;
	}
	if (top==NULL) Error("no image.");

	if (argc==10 || argc==12) {
	    if ((x1=atoi(argv[argc-7]))>
		(x2=atoi(argv[argc-4])) || x1>X2 || x2<X1 ||
		(y1=atoi(argv[argc-6]))>
		(y2=atoi(argv[argc-3])) || y1>Y2 || y2<Y1 ||
		(z1=atoi(argv[argc-5]))>
		(z2=atoi(argv[argc-2])) || z1>Z2 || z2<Z1) Error("bad area.");

	    X1=x1; Y1=y1; Z1=z1; X2=x2; Y2=y2; Z2=z2;
	}
	if ((BPS=atoi(argv[(argc==4 || argc==6)?argc-2:argc-8]))<1 ||
	    BPS>8*sizeof(Cell)) Error("bad BPS.");

	if (argc==6 || argc==12) {
	    if ((step=atof(argv[3]))<=0.0) Error("bad step.");

	    base=atof(argv[2]);
	    roof=base+step*(double)((1<<BPS)-1);
	}
	none=atof(argv[1]);

	X2-=(X1-1);
	Y2-=(Y1-1);
	Z2-=(Z1-1);

	if ((out=(Cell **)(sum=sy=ALLOC(Sum *,Y2)))==NULL) Error(mae);

	for (y=0; y<Y2; y++, sy++) if ((*sy=ALLOC(Sum,X2))==NULL) Error(mae);

	len=1; for (z=Z2-1; z>=10; z/=10) ++len;
	(void)sprintf(format,"%%0%dd",len);

	for (z=0; z<Z2; z++) {
	    for (sy=sum,   y=0; y<Y2; y++, sy++)
	    for (sx=(*sy), x=0; x<X2; x++, sx++) sx->d=(double)(sx->i=0);

	    for (list=top; list!=NULL; list=list->next)
		if ((Dz=z+Z1-list->Dz)>=0 && Dz<list->Nz) {
		    mask=list->mask+Dz;
		    data=list->data+Dz;

		    ReadImageFile(mask->path,&x,&y,NULL,&mIn,NULL);
		    if (x!=list->Nx || y!=list->Ny) {
			(void)fputs(mask->path,stderr); Error(bis);
		    }
		    ReadImageFile(data->path,&x,&y,NULL,&dIn,NULL);
		    if (x!=list->Nx || y!=list->Ny) {
			(void)fputs(data->path,stderr); Error(bis);
		    }
		    Dx=list->Dx-X1; x1=(Dx>=0)?0:-Dx; if ((x2=X2-Dx)>x) x2=x;
		    Dy=list->Dy-Y1; y1=(Dy>=0)?0:-Dy; if ((y2=Y2-Dy)>y) y2=y;
		    for (sy=sum  +Dy+(y=y1); y<y2; y++, sy++)
		    for (sx=(*sy)+Dx+(x=x1); x<x2; x++, sx++)
			if (mIn[y][x]) {
			    ++sx->i;
			    sx->d+=(data->base+data->step*(double)dIn[y][x]);
			}

		    for (y=list->Ny-1; y>=0; y--) free(dIn[y]); free(dIn);
		    for (y=list->Ny-1; y>=0; y--) free(mIn[y]); free(mIn);
		}

	    for (sy=sum,   y=0; y<Y2; y++, sy++)
	    for (sx=(*sy), x=0; x<X2; x++, sx++) {
		val=(sx->i)?sx->d/(double)sx->i:none;

		if (x==0 && y==0)
		    min=max=val;
		else
		    if (val<min) min=val; else if (val>max) max=val;
	    }
	    if (argc==4 || argc==10) {
		if (min==max) (void)fputs("no value range (warning).\n",stderr);

		step=(max-min)/(double)((1<<BPS)-1); base=min; roof=max;
	    }
	    (void)sprintf(slice,format,z);
	    (void)sprintf(desc,"%lf\t%lf\t%lf\t%18.16lf",min,max,base,step);
	    (void)printf("%s\t%s\n",slice,desc);

	    for (sy=sum,   y=0; y<Y2; y++, sy++)
	    for (sx=(*sy), x=0; x<X2; x++, sx++) {
		val=(sx->i)?sx->d/(double)sx->i:none;

		out[y][x]=(val<=base)?0:
			  (val>=roof)?(Cell)((1<<BPS)-1):
				      (Cell)((val-base)/step+0.5);
	    }
	    (void)sprintf(path,"%s/%s.tif",argv[argc-1],slice);
	    StoreImageFile(path,X2,Y2,BPS,out,desc);
	}
	return 0;
}
