
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "cell.h"
#include "rif.h"

extern void	Error();

int	main(argc,argv)
int	argc;
char	**argv;
{
	int		Ngx,Ngy,Nhx,Nhy,Dx1,Dy1,Dx2,Dy2,
			Nghx,Nghy,dy,yg,yh,Ny,dx,xg,xh,Nx,y,x;
	Cell		**G,**H,**Gy,**Hy,*Gx,*Hx,g,h;
	double		Bgh,Sg,Sh,sqrs,diff;
	unsigned long	pels;

	if (argc!=7 && argc!=11)
Error("usage : rmsd_2d TIFF1 base1 step1 TIFF2 base2 step2 {Dx1 Dy1 Dx2 Dy2}");

	ReadImageFile(argv[1],&Ngx,&Ngy,NULL,&G,NULL);
	ReadImageFile(argv[4],&Nhx,&Nhy,NULL,&H,NULL);

	Bgh=atof(argv[2])-atof(argv[5]);
	Sg=atof(argv[3]);
	Sh=atof(argv[6]);

	if (argc==7) {
	    Dx1=1-Nhx; Dx2=Ngx-1;
	    Dy1=1-Nhy; Dy2=Ngy-1;
	}
	else
	    if ((Dx1=atoi(argv[ 7]))>
		(Dx2=atoi(argv[ 9])) || Dx1<=(-Nhx) || Dx2>=Ngx ||
		(Dy1=atoi(argv[ 8]))>
		(Dy2=atoi(argv[10])) || Dy1<=(-Nhy) || Dy2>=Ngy)
		Error("bad range of distance.");

	Nghx=Ngx-Nhx;
	Nghy=Ngy-Nhy;

	for (dy=Dy1; dy<=Dy2; dy++) {
	    if (dy<0) {
		yg=0; yh=(-dy); Ny=(dy>=Nghy)?Ngy:Nhy+dy;
	    }
	    else {
		yg=dy; yh=0; Ny=(dy>=Nghy)?Ngy-dy:Nhy;
	    }
	    for (dx=Dx1; dx<=Dx2; dx++) {
		if (dx<0) {
		    xg=0; xh=(-dx); Nx=(dx>=Nghx)?Ngx:Nhx+dx;
		}
		else {
		    xg=dx; xh=0; Nx=(dx>=Nghx)?Ngx-dx:Nhx;
		}

		pels=0; sqrs=0.0;
		for (Gy=G+yg,
		     Hy=H+yh, y=0; y<Ny; y++)
		for (Gx=(*(Gy++))+xg,
		     Hx=(*(Hy++))+xh, x=0; x<Nx; x++) {
		    g=(*(Gx++));
		    h=(*(Hx++));
		    if (g && h) {
			++pels;
			diff=Bgh+Sg*(double)g-Sh*(double)h; sqrs+=(diff*diff);
		    }
		}
		if (pels)
		    (void)printf("%d\t%d\t%lu\t%lf\n",
				 dx,dy,pels,sqrt(sqrs/(double)pels));
	    }
	}
	return 0;
}
