
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "sif.h"

extern void	Error();

#define LEN	1023

typedef struct {
		int	i;
		double	d;
	} Sum;

#define ALLOC(type,size)	(type *)malloc((size_t)(size)*sizeof(type))

int	main(argc,argv)
int	argc;
char	**argv;
{
	double	Bx,By,Bz,Sx,Sy,Sz,Rx,Ry,Rz,X,Y,Z,V,x1,x2,y1,y2,z1,z2,v1,v2,
		none,base,step,roof;
	int	Nx,Ny,Nz,z,y,x,BPS,len,No=0;
	Sum	***sum;
	Cell	***cell;
	char	format[LEN],path[LEN],
		*mae="memory allocation error.";

	if (argc!=13 && argc!=15)
	    Error(
    "usage : xyzv2t Bx By Bz Sx Sy Sz Nx Ny Nz none {base step} BPS directory"
	    );

	Bx=atof(argv[1]);
	By=atof(argv[2]);
	Bz=atof(argv[3]);

	if ((Sx=atof(argv[4]))<=0.0 ||
	    (Sy=atof(argv[5]))<=0.0 ||
	    (Sz=atof(argv[6]))<=0.0) Error("bad pixel size.");

	if ((Nx=atoi(argv[7]))<=0 ||
	    (Ny=atoi(argv[8]))<=0 ||
	    (Nz=atoi(argv[9]))<=0) Error("bad pixel number.");

	if ((cell=(Cell ***)(sum=ALLOC(Sum **,Nz)))==NULL) Error(mae);

	for (z=0; z<Nz; z++) {
	    if ((sum[z]=ALLOC(Sum *,Ny))==NULL) Error(mae);

	    for (y=0; y<Ny; y++) {
		if ((sum[z][y]=ALLOC(Sum,Nx))==NULL) Error(mae);

		for (x=0; x<Nx; x++) sum[z][y][x].d=(double)(sum[z][y][x].i=0);
	    }
	}
	Bx-=(Sx/2.0); Rx=Bx+Sx*(double)Nx;
	By-=(Sy/2.0); Ry=By+Sy*(double)Ny;
	Bz-=(Sz/2.0); Rz=Bz+Sz*(double)Nz;

	while (scanf("%lf %lf %lf %lf",&X,&Y,&Z,&V)==4) {
	    if (X>=Bx && X<Rx && Y>=By && Y<Ry && Z>=Bz && Z<Rz) {
		x=(int)((X-Bx)/Sx);
		y=(int)((Y-By)/Sy);
		z=(int)((Z-Bz)/Sz); ++sum[z][y][x].i; sum[z][y][x].d+=V;
	    }
	    if (++No==1) {
		x1=x2=X; y1=y2=Y; z1=z2=Z; v1=v2=V;
	    }
	    else {
		if (X<x1) x1=X; else if (X>x2) x2=X;
		if (Y<y1) y1=Y; else if (Y>y2) y2=Y;
		if (Z<z1) z1=Z; else if (Z>z2) z2=Z;
		if (V<v1) v1=V; else if (V>v2) v2=V;
	    }
	}
	if (No==0) Error("no data.");

	printf("%lf\t%lf\n%lf\t%lf\n%lf\t%lf\n%lf\t%lf\n",
	       x1,x2,y1,y2,z1,z2,v1,v2);

	if ((BPS=atoi(argv[argc-2]))<1 || BPS>8*sizeof(Cell)) Error("bad BPS.");

	if (argc==13) {
	    if (v1==v2) fputs("no value range (warning).\n",stderr);

	    step=(v2-v1)/(double)((1<<BPS)-1); base=v1; roof=v2;
	}
	else {
	    if ((step=atof(argv[12]))<=0.0) Error("bad step.");

	    base=atof(argv[11]); roof=base+step*(double)((1<<BPS)-1);
	}
	none=atof(argv[10]);

	len=1; for (z=Nz-1; z>=10; z/=10) ++len;
	sprintf(format,"%s/%%0%dd.tif",argv[argc-1],len);

	for (z=0; z<Nz; z++) {
	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++) {
		V=(sum[z][y][x].i)?sum[z][y][x].d/(double)sum[z][y][x].i:none;

		cell[z][y][x]=(V<=base)?0:
			      (V>=roof)?(Cell)((1<<BPS)-1):
					(Cell)((V-base)/step+0.5);
	    }
	    sprintf(path,format,z);
	    StoreImageFile(path,Nx,Ny,BPS,cell[z],NULL);
	}
	return 0;
}
